var recursiveDirRead = require('recursive-readdir');
var jsdocParse = require('jsdoc-parse');
var jsonServer = require('json-server');
var MemoryStream = require('memorystream');
var Q = require('q');

var localhostPortNumber = 3002;

var jsdocScriptsfolderPath = null;

process.argv.forEach(function (val, index, array) {
    if (index === 2) {
        jsdocScriptsfolderPath = val;
    }

    if (index == 3 && val) {
        console.log('setting localhost port number to be ' + val);
        localhostPortNumber = val;
    }
});

var concatedFileName = 'allJSDocScripts.js';


getArrayOfFiles()
    .then(parseJSDocToJSON, function () {
        console.log('error with paraseJSDocToJSON in promise');
    })
    .then(publishDB, function () {
        console.log('error with publishDB in promise');
    });



function getArrayOfFiles() {
    console.log('called function: getArrayOfFiles()');

    var getArrayFilesDeferred = Q.defer();

    recursiveDirRead(jsdocScriptsfolderPath, function (err, files) {

        if (err) {
            getArrayFilesDeferred.reject(new Error('error reading folder to get arary of files'));
        }

        else {
            console.log(files);
            getArrayFilesDeferred.resolve(files);
        }

    });

    return getArrayFilesDeferred.promise;

}

function parseJSDocToJSON(data) {

    var parseJSDocToJSONDeferred = Q.defer();

    var memStream = new MemoryStream(null, {
        readable: false
    });


    var pipeToMemStreamEvent = jsdocParse({src: data})
        .on('end', function (err) {
            //console.log('whats in memStream', memStream);
            if (err) {
                parseJSDocToJSONDeferred.reject('Failed to pipe jsDoc JSON into in memory object');
            }
            parseJSDocToJSONDeferred.resolve(memStream);
        })
        .pipe(memStream);
    return parseJSDocToJSONDeferred.promise;
}


function publishDB(inMemoryDB) {

    var inMemoryDBObj = {};
    inMemoryDBObj.data = JSON.parse(inMemoryDB.toString());
    //console.log('the in mem data is ', inMemoryDBObj)

    console.log('Started server on localhost: ' + localhostPortNumber);
    var server = jsonServer.create();

    server.use(jsonServer.defaults);

    var router = jsonServer.router(inMemoryDBObj);
    server.use(router);

    server.listen(localhostPortNumber);


}

